Gecode::SharedHandle Class Reference

The shared handle. More...

`#include <shared-object.hpp>`

## Classes

class | Object
| The shared object. More...

## Public Member Functions

| SharedHandle (void)
| Create shared handle with no object pointing to.
| SharedHandle (SharedHandle::Object *so)
| Create shared handle that points to shared object so.
| SharedHandle (const SharedHandle &sh)
| Copy constructor maintaining reference count.
SharedHandle & | operator= (const SharedHandle &sh)
| Assignment operator maintaining reference count.
| ~SharedHandle (void)
| Destructor that maintains reference count.
| operator bool (void) const
| Whether handle points to an object.

## Protected Member Functions

SharedHandle::Object * | object (void) const
| Access to the shared object.
void | object (SharedHandle::Object *n)
| Modify shared object.

## Detailed Description

The shared handle.

A shared handle provides access to an object that lives outside a space, and is shared between entities that possibly reside inside different spaces.

This is the base class that all shared handles must inherit from.

Definition at line 46 of file shared-object.hpp.

## Constructor & Destructor Documentation

## SharedHandle() [1/3]

Gecode::SharedHandle::SharedHandle | ( | void |  | ) |

inline

Create shared handle with no object pointing to.

Definition at line 122 of file shared-object.hpp.

## SharedHandle() [2/3]

Gecode::SharedHandle::SharedHandle | ( | SharedHandle::Object * | so | ) |

inline

Create shared handle that points to shared object so.

Definition at line 124 of file shared-object.hpp.

## SharedHandle() [3/3]

Gecode::SharedHandle::SharedHandle | ( | const SharedHandle & | sh | ) |

inline

Copy constructor maintaining reference count.

Definition at line 128 of file shared-object.hpp.

## ~SharedHandle()

Gecode::SharedHandle::~SharedHandle | ( | void |  | ) |

inline

Destructor that maintains reference count.

Definition at line 143 of file shared-object.hpp.

## Member Function Documentation

## operator=()

SharedHandle & Gecode::SharedHandle::operator= | ( | const SharedHandle & | sh | ) |

inline

Assignment operator maintaining reference count.

Definition at line 132 of file shared-object.hpp.

## operator bool()

Gecode::SharedHandle::operator bool | ( | void |  | ) | const

inline explicit

Whether handle points to an object.

Definition at line 139 of file shared-object.hpp.

## object() [1/2]

SharedHandle::Object * Gecode::SharedHandle::object | ( | void |  | ) | const

inline protected

Access to the shared object.

Definition at line 102 of file shared-object.hpp.

## object() [2/2]

void Gecode::SharedHandle::object | ( | SharedHandle::Object * | n | ) |

inline protected

Modify shared object.

Definition at line 116 of file shared-object.hpp.

The documentation for this class was generated from the following file:

- gecode/kernel/shared-object.hpp